Index: branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3115)
+++ branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3116)
@@ -7,4 +7,5 @@
    !!            3.0  !  2008-04  (NEMO team)  add in the reference version     
    !!            3.3  !  2010-09  (D. Storkey) add ice boundary conditions
+   !!            3.4  !  2011     (D. Storkey, J. Chanut) OBC-BDY merge
    !!----------------------------------------------------------------------
 #if defined key_bdy 
@@ -19,30 +20,69 @@
    PUBLIC
 
+   TYPE, PUBLIC ::   OBC_INDEX    !: Indices and weights which define the open boundary
+      INTEGER,          DIMENSION(jpbgrd) ::  nblen
+      INTEGER,          DIMENSION(jpbgrd) ::  nblenrim
+      INTEGER, POINTER, DIMENSION(:,:)   ::  nbi
+      INTEGER, POINTER, DIMENSION(:,:)   ::  nbj
+      INTEGER, POINTER, DIMENSION(:,:)   ::  nbr
+      INTEGER, POINTER, DIMENSION(:,:)   ::  nbmap
+      REAL   , POINTER, DIMENSION(:,:)   ::  nbw
+      REAL   , POINTER, DIMENSION(:)     ::  flagu
+      REAL   , POINTER, DIMENSION(:)     ::  flagv
+   END TYPE OBC_INDEX
+
+   TYPE, PUBLIC ::   OBC_DATA     !: Storage for external data
+      REAL, POINTER, DIMENSION(:)     ::  ssh
+      REAL, POINTER, DIMENSION(:)     ::  u2d
+      REAL, POINTER, DIMENSION(:)     ::  v2d
+      REAL, POINTER, DIMENSION(:,:)   ::  u3d
+      REAL, POINTER, DIMENSION(:,:)   ::  v3d
+      REAL, POINTER, DIMENSION(:,:)   ::  tem
+      REAL, POINTER, DIMENSION(:,:)   ::  sal
+#if defined key_lim2
+      REAL, POINTER, DIMENSION(:)     ::  frld
+      REAL, POINTER, DIMENSION(:)     ::  hicif
+      REAL, POINTER, DIMENSION(:)     ::  hsnif
+#endif
+   END TYPE OBC_DATA
+
    !!----------------------------------------------------------------------
    !! Namelist variables
    !!----------------------------------------------------------------------
-   CHARACTER(len=80) ::   cn_mask        !: Name of unstruct. bdy mask file
-   CHARACTER(len=80) ::   cn_dta_frs_T   !: Name of unstruct. bdy data file at T points for FRS conditions
-   CHARACTER(len=80) ::   cn_dta_frs_U   !: Name of unstruct. bdy data file at U points for FRS conditions
-   CHARACTER(len=80) ::   cn_dta_frs_V   !: Name of unstruct. bdy data file at V points for FRS conditions
-   CHARACTER(len=80) ::   cn_dta_fla_T   !: Name of unstruct. bdy data file at T points for Flather scheme
-   CHARACTER(len=80) ::   cn_dta_fla_U   !: Name of unstruct. bdy data file at U points for Flather scheme
-   CHARACTER(len=80) ::   cn_dta_fla_V   !: Name of unstruct. bdy data file at V points for Flather scheme
+   CHARACTER(len=80), DIMENSION(jp_bdy) ::   cn_coords_file !: Name of bdy coordinates file
+   CHARACTER(len=80)                    ::   cn_mask_file   !: Name of bdy mask file
    !
-   LOGICAL ::   ln_tides = .false.    !: =T apply tidal harmonic forcing along open boundaries
-   LOGICAL ::   ln_vol  = .false.     !: =T volume correction             
-   LOGICAL ::   ln_mask = .false.     !: =T read bdymask from file
-   LOGICAL ::   ln_clim = .false.     !: =T bdy data files contain  1 time dump  (-->bdy forcing will be constant) 
-   !                                  !                         or 12 months     (-->bdy forcing will be cyclic) 
-   LOGICAL ::   ln_dyn_fla  = .false. !: =T Flather boundary conditions on barotropic velocities
-   LOGICAL ::   ln_dyn_frs  = .false. !: =T FRS boundary conditions on velocities
-   LOGICAL ::   ln_tra_frs  = .false. !: =T FRS boundary conditions on tracers (T and S)
-   LOGICAL ::   ln_ice_frs  = .false. !: =T FRS boundary conditions on seaice (leads fraction, ice depth, snow depth)
+   LOGICAL, DIMENSION(jp_bdy) ::   ln_coords_file           !: =T read bdy coordinates from file; 
+   !                                                        !: =F read bdy coordinates from namelist
+   LOGICAL                    ::   ln_mask_file             !: =T read bdymask from file
+   LOGICAL                    ::   ln_vol                   !: =T volume correction             
    !
-   INTEGER ::   nn_rimwidth = 7       !: boundary rim width
-   INTEGER ::   nn_dtactl   = 1	     !: = 0 use the initial state as bdy dta ; = 1 read it in a NetCDF file
-   INTEGER ::   nn_volctl   = 1       !: = 0 the total volume will have the variability of the surface Flux E-P 
-   !                                  !  = 1 the volume will be constant during all the integration.
+   INTEGER                    ::   nb_bdy                   !: number of open boundary sets
+   INTEGER, DIMENSION(jp_bdy) ::   nn_rimwidth              !: boundary rim width for Flow Relaxation Scheme
+   INTEGER                    ::   nn_volctl                !: = 0 the total volume will have the variability of the surface Flux E-P 
+   !                                                        !  = 1 the volume will be constant during all the integration.
+   INTEGER, DIMENSION(jp_bdy) ::   nn_dyn2d                 ! Choice of boundary condition for barotropic variables (U,V,SSH)
+   INTEGER, DIMENSION(jp_bdy) ::   nn_dyn2d_dta      	    !: = 0 use the initial state as bdy dta ; 
+                                                            !: = 1 read it in a NetCDF file
+                                                            !: = 2 read tidal harmonic forcing from a NetCDF file
+                                                            !: = 3 read external data AND tidal harmonic forcing from NetCDF files
+   INTEGER, DIMENSION(jp_bdy) ::   nn_dyn3d                 ! Choice of boundary condition for baroclinic velocities 
+   INTEGER, DIMENSION(jp_bdy) ::   nn_dyn3d_dta      	    !: = 0 use the initial state as bdy dta ; 
+                                                            !: = 1 read it in a NetCDF file
+   INTEGER, DIMENSION(jp_bdy) ::   nn_tra                   ! Choice of boundary condition for active tracers (T and S)
+   INTEGER, DIMENSION(jp_bdy) ::   nn_tra_dta      	    !: = 0 use the initial state as bdy dta ; 
+                                                            !: = 1 read it in a NetCDF file
+#if defined key_lim2
+   INTEGER, DIMENSION(jp_bdy) ::   nn_ice_lim2              ! Choice of boundary condition for sea ice variables 
+   INTEGER, DIMENSION(jp_bdy) ::   nn_ice_lim2_dta          !: = 0 use the initial state as bdy dta ; 
+                                                            !: = 1 read it in a NetCDF file
+#endif
+   !
+   INTEGER, DIMENSION(jp_bdy) ::   nn_dmp2d_in              ! Damping timescale (days) for 2D solution for inward radiation or FRS 
+   INTEGER, DIMENSION(jp_bdy) ::   nn_dmp2d_out             ! Damping timescale (days) for 2D solution for outward radiation 
+   INTEGER, DIMENSION(jp_bdy) ::   nn_dmp3d_in              ! Damping timescale (days) for 3D solution for inward radiation or FRS 
+   INTEGER, DIMENSION(jp_bdy) ::   nn_dmp3d_out             ! Damping timescale (days) for 3D solution for outward radiation
 
+   
    !!----------------------------------------------------------------------
    !! Global variables
@@ -52,31 +92,21 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   bdyvmask   !: Mask defining computational domain at V-points
 
+   REAL(wp)                                    ::   bdysurftot !: Lateral surface of unstructured open boundary
+
+   REAL(wp), POINTER, DIMENSION(:,:)           ::   pssh       !: 
+   REAL(wp), POINTER, DIMENSION(:,:)           ::   phur       !: 
+   REAL(wp), POINTER, DIMENSION(:,:)           ::   phvr       !: Pointers for barotropic fields 
+   REAL(wp), POINTER, DIMENSION(:,:)           ::   pu2d       !: 
+   REAL(wp), POINTER, DIMENSION(:,:)           ::   pv2d       !: 
+
    !!----------------------------------------------------------------------
-   !! Unstructured open boundary data variables
+   !! open boundary data variables
    !!----------------------------------------------------------------------
-   INTEGER, DIMENSION(jpbgrd) ::   nblen    = 0           !: Size of bdy data on a proc for each grid type
-   INTEGER, DIMENSION(jpbgrd) ::   nblenrim = 0           !: Size of bdy data on a proc for first rim ind
-   INTEGER, DIMENSION(jpbgrd) ::   nblendta = 0           !: Size of bdy data in file
 
-   INTEGER, DIMENSION(jpbdim,jpbgrd) ::   nbi, nbj        !: i and j indices of bdy dta
-   INTEGER, DIMENSION(jpbdim,jpbgrd) ::   nbr             !: Discrete distance from rim points
-   INTEGER, DIMENSION(jpbdim,jpbgrd) ::   nbmap           !: Indices of data in file for data in memory 
-    
-   REAL(wp) ::   bdysurftot	                            !: Lateral surface of unstructured open boundary
-
-   REAL(wp), DIMENSION(jpbdim)        ::   flagu, flagv   !: Flag for normal velocity compnt for velocity components
-   REAL(wp), DIMENSION(jpbdim,jpbgrd) ::   nbw            !: Rim weights of bdy data
-
-   REAL(wp), DIMENSION(jpbdim)     ::   sshbdy            !: Now clim of bdy sea surface height (Flather)
-   REAL(wp), DIMENSION(jpbdim)     ::   ubtbdy, vbtbdy    !: Now clim of bdy barotropic velocity components
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   tbdy  , sbdy      !: Now clim of bdy temperature and salinity  
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ubdy  , vbdy	  !: Now clim of bdy velocity components
-   REAL(wp), DIMENSION(jpbdim) ::   sshtide               !: Tidal boundary array : SSH
-   REAL(wp), DIMENSION(jpbdim) ::   utide, vtide          !: Tidal boundary array : U and V
-#if defined key_lim2
-   REAL(wp), DIMENSION(jpbdim) ::   frld_bdy    !: now ice leads fraction climatology   
-   REAL(wp), DIMENSION(jpbdim) ::   hicif_bdy   !: Now ice  thickness climatology
-   REAL(wp), DIMENSION(jpbdim) ::   hsnif_bdy   !: now snow thickness
-#endif
+   INTEGER,  DIMENSION(jp_bdy)                     ::   nn_dta            !: =0 => *all* data is set to initial conditions
+                                                                          !: =1 => some data to be read in from data files
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::   dta_global        !: workspace for reading in global data arrays
+   TYPE(OBC_INDEX), DIMENSION(jp_bdy), TARGET      ::   idx_bdy           !: bdy indices (local process)
+   TYPE(OBC_DATA) , DIMENSION(jp_bdy)              ::   dta_bdy           !: bdy external data (local process)
 
    !!----------------------------------------------------------------------
@@ -94,7 +124,6 @@
       !!----------------------------------------------------------------------
       !
-      ALLOCATE( bdytmask(jpi,jpj) , tbdy(jpbdim,jpk) , sbdy(jpbdim,jpk) ,     &
-         &      bdyumask(jpi,jpj) , ubdy(jpbdim,jpk) ,                        &
-         &      bdyvmask(jpi,jpj) , vbdy(jpbdim,jpk) ,                    STAT=bdy_oce_alloc )
+      ALLOCATE( bdytmask(jpi,jpj) , bdyumask(jpi,jpj), bdyvmask(jpi,jpj),                    &  
+         &      STAT=bdy_oce_alloc )
          !
       IF( lk_mpp             )   CALL mpp_sum ( bdy_oce_alloc )
@@ -112,2 +141,3 @@
    !!======================================================================
 END MODULE bdy_oce
+
Index: branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_par.F90
===================================================================
--- branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_par.F90	(revision 3115)
+++ branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_par.F90	(revision 3116)
@@ -17,8 +17,12 @@
 
    LOGICAL, PUBLIC, PARAMETER ::   lk_bdy  = .TRUE.   !: Unstructured Ocean Boundary Condition flag
-   INTEGER, PUBLIC, PARAMETER ::   jpbdta  = 20000    !: Max length of bdy field in file
-   INTEGER, PUBLIC, PARAMETER ::   jpbdim  = 20000    !: Max length of bdy field on a processor
+   INTEGER, PUBLIC, PARAMETER ::   jp_bdy  = 10       !: Maximum number of bdy sets
    INTEGER, PUBLIC, PARAMETER ::   jpbtime = 1000     !: Max number of time dumps per file
-   INTEGER, PUBLIC, PARAMETER ::   jpbgrd  = 6	      !: Number of horizontal grid types used  (T, u, v, f)
+   INTEGER, PUBLIC, PARAMETER ::   jpbgrd  = 3	      !: Number of horizontal grid types used  (T, U, V)
+
+   !! Flags for choice of schemes
+   INTEGER, PUBLIC, PARAMETER ::   jp_none         = 0        !: Flag for no open boundary condition
+   INTEGER, PUBLIC, PARAMETER ::   jp_frs          = 1        !: Flag for Flow Relaxation Scheme
+   INTEGER, PUBLIC, PARAMETER ::   jp_flather      = 2        !: Flag for Flather
 #else
    !!----------------------------------------------------------------------
Index: branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3115)
+++ branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3116)
@@ -10,19 +10,20 @@
    !!            3.3  !  2010-09  (E.O'Dea) modifications for Shelf configurations 
    !!            3.3  !  2010-09  (D.Storkey) add ice boundary conditions
+   !!            3.4  ????????????????
    !!----------------------------------------------------------------------
 #if defined key_bdy
    !!----------------------------------------------------------------------
-   !!   'key_bdy'                     Unstructured Open Boundary Conditions
-   !!----------------------------------------------------------------------
-   !!   bdy_dta_frs    : read u, v, t, s data along open boundaries
-   !!   bdy_dta_fla : read depth-mean velocities and elevation along open boundaries        
+   !!   'key_bdy'                     Open Boundary Conditions
+   !!----------------------------------------------------------------------
+   !!    bdy_dta        : read external data along open boundaries from file
+   !!    bdy_dta_init   : initialise arrays etc for reading of external data
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
    USE phycst          ! physical constants
-   USE bdy_oce         ! ocean open boundary conditions
+   USE bdy_oce         ! ocean open boundary conditions  
    USE bdytides        ! tidal forcing at boundaries
-   USE iom
-   USE ioipsl
+   USE fldread         ! read input fields
+   USE iom             ! IOM library
    USE in_out_manager  ! I/O logical units
 #if defined key_lim2
@@ -33,30 +34,18 @@
    PRIVATE
 
-   PUBLIC   bdy_dta_frs      ! routines called by step.F90
-   PUBLIC   bdy_dta_fla 
-   PUBLIC   bdy_dta_alloc    ! routine called by bdy_init.F90
-
-   INTEGER ::   numbdyt, numbdyu, numbdyv                      ! logical units for T-, U-, & V-points data file, resp.
-   INTEGER ::   ntimes_bdy                                     ! exact number of time dumps in data files
-   INTEGER ::   nbdy_b, nbdy_a                                 ! record of bdy data file for before and after time step
-   INTEGER ::   numbdyt_bt, numbdyu_bt, numbdyv_bt             ! logical unit for T-, U- & V-points data file, resp.
-   INTEGER ::   ntimes_bdy_bt                                  ! exact number of time dumps in data files
-   INTEGER ::   nbdy_b_bt, nbdy_a_bt                           ! record of bdy data file for before and after time step
-
-   INTEGER, DIMENSION (jpbtime) ::   istep, istep_bt           ! time array in seconds in each data file
-
-   REAL(wp) ::  zoffset                                        ! time offset between time origin in file & start time of model run
-
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tbdydta, sbdydta   ! time interpolated values of T and S bdy data   
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ubdydta, vbdydta   ! time interpolated values of U and V bdy data 
-   REAL(wp), DIMENSION(jpbdim,2)     ::   ubtbdydta, vbtbdydta ! Arrays used for time interpolation of bdy data   
-   REAL(wp), DIMENSION(jpbdim,2)     ::   sshbdydta            ! bdy data of ssh
-
-#if defined key_lim2
-   REAL(wp), DIMENSION(jpbdim,2)     ::   frld_bdydta          ! }
-   REAL(wp), DIMENSION(jpbdim,2)     ::   hicif_bdydta         ! } Arrays used for time interp. of ice bdy data 
-   REAL(wp), DIMENSION(jpbdim,2)     ::   hsnif_bdydta         ! }
-#endif
-
+   PUBLIC   bdy_dta          ! routine called by step.F90 and dynspg_ts.F90
+   PUBLIC   bdy_dta_init     ! routine called by nemogcm.F90
+
+   INTEGER, ALLOCATABLE, DIMENSION(:)   ::   nb_bdy_fld        ! Number of fields to update for each boundary set.
+   INTEGER                              ::   nb_bdy_fld_sum    ! Total number of fields to update for all boundary sets.
+
+   LOGICAL,           DIMENSION(jp_bdy) ::   ln_full_vel_array ! =T => full velocities in 3D boundary conditions
+                                                               ! =F => baroclinic velocities in 3D boundary conditions
+
+   TYPE(FLD), PUBLIC, ALLOCATABLE, DIMENSION(:), TARGET ::   bf        ! structure of input fields (file informations, fields read)
+
+   TYPE(MAP_POINTER), ALLOCATABLE, DIMENSION(:) :: nbmap_ptr   ! array of pointers to nbmap
+
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
